package bamp.basedata.webapi;

import kd.bos.bd.service.AssignService;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.basedata.BaseDataResponse;
import kd.bos.openapi.api.plugin.ApiSavePlugin;

import java.util.*;

/*
* 通用接口扩展插件
* wangj 2025-01-08
* 主要功能：根据禁用状态设置禁用人
 */
public class TransformApiData implements ApiSavePlugin {
    @Override
    public List<Map<String, Object>> preHandleRequestData(List<Map<String, Object>> reqData) {
//        Set<Long> orgIds = new HashSet(selectedRows.size());
//        selectedRows.forEach((r) -> {
//            orgIds.add(Long.valueOf(r.getPrimaryKeyValue().toString()));
//        });
//        BaseDataResponse response = (new AssignService(this.entityId)).assign(this.useOrg, this.appId, this.dataIds, orgIds, true);
//        if(response.isSuccess()==true){

//        }else{
//            response.getErrorMsg();
//        }
        for (Map<String, Object> map : reqData) {
            if(map.get("enable")!=null && !"".equals(map.get("enable")) && "0".equals(map.get("enable"))){
                Map<String, Object> modifierMap = (Map<String, Object>) map.get("modifier");
                Map<String, Object> disablerMap = new HashMap<>();
                disablerMap.put("number",modifierMap.get("number"));
                map.put("disabler",disablerMap);
                map.put("disabledate",map.get("modifytime"));
            }else{
                Map<String, Object> disablerMap = new HashMap<>();
                disablerMap.put("number","");
                map.put("disabler",disablerMap);
                map.put("disabledate",null);
            }

            if(map.get("modifier")!=null && !"".equals(map.get("modifier"))){
                Map<String, Object> modifierMap = (Map<String, Object>) map.get("modifier");
                Map<String, Object> disablerMap = new HashMap<>();
                disablerMap.put("number",modifierMap.get("number"));
                map.put("pznm_modifier_xh",disablerMap);
            }

            if(map.get("auditor")!=null && !"".equals(map.get("auditor"))){
                Map<String, Object> modifierMap = (Map<String, Object>) map.get("auditor");
                Map<String, Object> disablerMap = new HashMap<>();
                disablerMap.put("number",modifierMap.get("number"));
                map.put("pznm_auditor_xh",disablerMap);
            }
        }
        return reqData;
    }
}
